import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;

public class PaymentDemo {
    public static void main(String[] args) throws Exception {
        // 组装数据
        String pid = "1000";
        String type = "alipay";
        String out_trade_no = "UNIQUE_ORDER_NUMBER";
        String notify_url = "http://您的站点域名/notify_url.php";
        String return_url = "http://您的站点域名/return_url.php";
        String name = "一个奥利奥";
        String money = "1.00";
        String sitename = "我的测试网站";
        String secret_key = "您的密钥";
        
        // 参数排序
        TreeMap<String, String> params = new TreeMap<>();
        params.put("pid", pid);
        params.put("type", type);
        params.put("out_trade_no", out_trade_no);
        params.put("notify_url", notify_url);
        params.put("return_url", return_url);
        params.put("name", name);
        params.put("money", money);
        params.put("sitename", sitename);
        
        // 计算签名
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, String> entry : params.entrySet()) {
            sb.append(entry.getKey()).append('=').append(entry.getValue()).append('&');
        }
        sb.append(secret_key); // 拼接密钥
        String signStr = sb.toString();
        String sign = getMd5(signStr);
        
        // 发起请求
        String urlString = "https://demo.com/mapi.php";
        URL url = new URL(urlString);
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.setRequestMethod("POST");
        conn.setDoOutput(true);
        
        // 传递数据
        String postData = "";
        for (Map.Entry<String, String> entry : params.entrySet()) {
            postData += URLEncoder.encode(entry.getKey(), "UTF-8") + "="
                    + URLEncoder.encode(entry.getValue(), "UTF-8") + "&";
        }
        postData += "sign=" + URLEncoder.encode(sign, "UTF-8") + "&sign_type=MD5";
        
        OutputStream os = conn.getOutputStream();
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
        writer.write(postData);
        writer.flush();
        writer.close();
        os.close();
        
        // 获取响应
        int responseCode = conn.getResponseCode();
        if (responseCode == HttpURLConnection.HTTP_OK) {
            BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String inputLine;
            StringBuffer response = new StringBuffer();
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine);
            }
            in.close();
            // 打印响应内容
            System.out.println(response.toString());
        } else {
            System.out.println("POST请求失败！");
        }
    }
    
    // MD5计算函数
    public static String getMd5(String input) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] messageDigest = md.digest(input.getBytes());
            BigInteger no = new BigInteger(1, messageDigest);
            String hashtext = no.toString(16);
            while (hashtext.length() < 32) {
                hashtext = "0" + hashtext;
            }
            return hashtext;
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
    }
}