
import hashlib
import requests

# 基本支付信息
pid = "1000"
type = "alipay"
out_trade_no = "UNIQUE_ORDER_NUMBER"
notify_url = "http://您的站点域名/notify_url.php"
return_url = "http://您的站点域名/return_url.php"
name = "一个奥利奥"
money = "1.00"
secret_key = "您的密钥"

# 签名数据
sign_data = {
    "pid": pid,
    "type": type,
    "out_trade_no": out_trade_no,
    "notify_url": notify_url,
    "return_url": return_url,
    "name": name,
    "money": money
}

# 计算签名
sorted_keys = sorted(sign_data)
sign_string = "&".join(f"{k}={sign_data[k]}" for k in sorted_keys) + secret_key
sign = hashlib.md5(sign_string.encode()).hexdigest()

# 发起请求
url = "https://demo.com/mapi.php"
data = {**sign_data, "sign": sign, "sign_type": "MD5"}
response = requests.post(url, data=data)

# 处理服务器响应
if response:
    print(response.json())
else:
    # 请求失败的处理
    print("请求失败")